<template>
    <i-form :model="this.data" class='app-form info-form-mode' ref='form'  id='form' style="">
    <input style="display:none;" />
    <row >
    <tabs :animated="false" name='form' :value="detailsModel.form.activiedPage" 
        @on-click="detailsModel.form.clickPage($event)">
            <tab-pane v-show="detailsModel.formpage1.visible" name='formpage1' :index="0" tab='form' class=''  
                :label="(h) =>{
                    return h('span',{
                        class:'caption'
                    },[
                    $t('entities.emwplist.main9_form.details.formpage1')
                    ])
                }">
                    
<i-col v-show="detailsModel.grouppanel2.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel2.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwplist.main9_form.details.grouppanel2')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.emwplistid.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='emwplistid' :itemRules="this.rules.emwplistid" class='' :caption="$t('entities.emwplist.main9_form.details.emwplistid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.emwplistid.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='emwplistid'
:value="data.emwplistid" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.wplisttype.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='wplisttype' :itemRules="this.rules.wplisttype" class='' :caption="$t('entities.emwplist.main9_form.details.wplisttype')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wplisttype.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='wplisttype'
:value="data.wplisttype" tag='EMWPLISTTYPE' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.adate.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='adate' :itemRules="this.rules.adate" class='' :caption="$t('entities.emwplist.main9_form.details.adate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.adate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='adate'
:value="data.adate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.useto.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='useto' :itemRules="this.rules.useto" class='' :caption="$t('entities.emwplist.main9_form.details.useto')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.useto.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='useto'
:value="data.useto" tag='EMUSETO' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.grouppanel1.visible" :style="{}"  :md="{ span: 24, offset: 0 }" :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel1.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwplist.main9_form.details.grouppanel1')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.equipname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='equipname' :itemRules="this.rules.equipname" class='' :caption="$t('entities.emwplist.main9_form.details.equipname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.equipname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='equipname'
:value="data.equipname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.objname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='objname' :itemRules="this.rules.objname" class='' :caption="$t('entities.emwplist.main9_form.details.objname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.objname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='objname'
:value="data.objname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.equips.visible" :style="{}"  :md="{ span: 24, offset: 0 }" :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='equips' :itemRules="this.rules.equips" class='' :caption="$t('entities.emwplist.main9_form.details.equips')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.equips.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='equips'
:value="data.equips" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.aempname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='aempname' :itemRules="this.rules.aempname" class='' :caption="$t('entities.emwplist.main9_form.details.aempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.aempname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='aempname'
:value="data.aempname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.deptname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='deptname' :itemRules="this.rules.deptname" class='' :caption="$t('entities.emwplist.main9_form.details.deptname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.deptname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='deptname'
:value="data.deptname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.teamname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='teamname' :itemRules="this.rules.teamname" class='' :caption="$t('entities.emwplist.main9_form.details.teamname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.teamname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='teamname'
:value="data.teamname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.hdate.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='hdate' :itemRules="this.rules.hdate" class='' :caption="$t('entities.emwplist.main9_form.details.hdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.hdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='hdate'
:value="data.hdate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.wpliststate.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='wpliststate' :itemRules="this.rules.wpliststate" class='' :caption="$t('entities.emwplist.main9_form.details.wpliststate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wpliststate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='wpliststate'
:value="data.wpliststate" tag='EMWPLISTSTATE' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.need3q.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='need3q' :itemRules="this.rules.need3q" class='' :caption="$t('entities.emwplist.main9_form.details.need3q')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.need3q.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='need3q'
:value="data.need3q" tag='YesNo' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.lastdate.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='lastdate' :itemRules="this.rules.lastdate" class='' :caption="$t('entities.emwplist.main9_form.details.lastdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.lastdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='lastdate'
:value="data.lastdate" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel18.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel18.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwplist.main9_form.details.grouppanel18')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.itemname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='itemname' :itemRules="this.rules.itemname" class='' :caption="$t('entities.emwplist.main9_form.details.itemname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.itemname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='itemname'
:value="data.itemname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.rempname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='rempname' :itemRules="this.rules.rempname" class='' :caption="$t('entities.emwplist.main9_form.details.rempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.rempname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='rempname'
:value="data.rempname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.asum.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='asum' :itemRules="this.rules.asum" class='' :caption="$t('entities.emwplist.main9_form.details.asum')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.asum.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='asum'
:value="data.asum" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.itemdesc.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='itemdesc' :itemRules="this.rules.itemdesc" class='' :caption="$t('entities.emwplist.main9_form.details.itemdesc')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.itemdesc.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='itemdesc'
:value="data.itemdesc" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.apprempname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='apprempname' :itemRules="this.rules.apprempname" class='' :caption="$t('entities.emwplist.main9_form.details.apprempname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.apprempname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='apprempname'
:value="data.apprempname" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.apprdate.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 8, offset: 0 }" :xl="{ span: 6, offset: 0 }">
    <app-form-item name='apprdate' :itemRules="this.rules.apprdate" class='' :caption="$t('entities.emwplist.main9_form.details.apprdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.apprdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='apprdate'
:value="data.apprdate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.wplistcostname.visible" :style="{}"  :md="{ span: 12, offset: 0 }" :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='wplistcostname' :itemRules="this.rules.wplistcostname" class='' :caption="$t('entities.emwplist.main9_form.details.wplistcostname')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.wplistcostname.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='wplistcostname'
:value="data.wplistcostname" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>
<i-col v-show="detailsModel.grouppanel3.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel3.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwplist.main9_form.details.grouppanel3')" :isShowCaption="true" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.druipart1.visible" :style="{'height': '300px !important',}"  :lg="{ span: 24, offset: 0 }">
    <app-form-druipart
    
    :formState="formState"
    :isForbidLoad="this.data.srfuf === '0'"
    paramItem='emwplist' 
    :parentdata='{"srfparentdefname":"WPLISTID","srfparentdename":"EMWPLIST","SRFPARENTTYPE":"DER1N","srfparentmode":"DER1N_EMWPLISTCOST_EMWPLIST_WPLISTID","SRFDER1NID":"DER1N_EMWPLISTCOST_EMWPLIST_WPLISTID"}'
    :parameters="[
        { pathName: 'emitems', parameterName: 'emitem' },
    ]"
    :context="context"
    :viewparams="viewparams"
    parameterName='emwplist'
    parentName="EMWPList"  
    refviewtype='DEGRIDVIEW9' 
    refreshitems='' 
    :ignorefieldvaluechange="ignorefieldvaluechange"
    viewname='emwplist-cost-grid-view9' 
    :data="JSON.stringify(this.data)" 
    @drdatasaved="drdatasaved($event)"
    style="height:300px;overflow: auto;">
</app-form-druipart>

</i-col>
    
    </row>
</app-form-group>

</i-col>


            </tab-pane> 
            <tab-pane v-show="detailsModel.formpage26.visible" name='formpage26' :index="1" tab='form' class=''  
                :label="(h) =>{
                    return h('span',{
                        class:'caption'
                    },[
                    $t('entities.emwplist.main9_form.details.formpage26')
                    ])
                }">
                    
<i-col v-show="detailsModel.grouppanel27.visible" :style="{}"  :lg="{ span: 24, offset: 0 }">
    <app-form-group layoutType="TABLE_24COL" titleStyle="" class='' uiActionGroup="detailsModel.grouppanel27.uiActionGroup" @groupuiactionclick="groupUIActionClick($event)" :caption="$t('entities.emwplist.main9_form.details.grouppanel27')" :isShowCaption="false" uiStyle="DEFAULT" :titleBarCloseMode="0" :isInfoGroupMode="true" >    
    <row>
        <i-col v-show="detailsModel.orgid.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='orgid' :itemRules="this.rules.orgid" class='' :caption="$t('entities.emwplist.main9_form.details.orgid')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.orgid.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='orgid'
:value="data.orgid" tag='PFCL_ORG' codelistType='STATIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.description.visible" :style="{}"  :lg="{ span: 24, offset: 0 }" :xl="{ span: 24, offset: 0 }">
    <app-form-item name='description' :itemRules="this.rules.description" class='' :caption="$t('entities.emwplist.main9_form.details.description')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.description.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='description'
:value="data.description" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.createman.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='createman' :itemRules="this.rules.createman" class='' :caption="$t('entities.emwplist.main9_form.details.createman')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.createman.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='createman'
:value="data.createman" tag='SysOperator' codelistType='DYNAMIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.createdate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='createdate' :itemRules="this.rules.createdate" class='' :caption="$t('entities.emwplist.main9_form.details.createdate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.createdate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='createdate'
:value="data.createdate" style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.updateman.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='updateman' :itemRules="this.rules.updateman" class='' :caption="$t('entities.emwplist.main9_form.details.updateman')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.updateman.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='updateman'
:value="data.updateman" tag='SysOperator' codelistType='DYNAMIC' style=""></app-span>
</app-form-item>

</i-col>
<i-col v-show="detailsModel.updatedate.visible" :style="{}"  :lg="{ span: 12, offset: 0 }" :xl="{ span: 12, offset: 0 }">
    <app-form-item name='updatedate' :itemRules="this.rules.updatedate" class='' :caption="$t('entities.emwplist.main9_form.details.updatedate')" uiStyle="DEFAULT" :labelWidth="130" :isShowCaption="true" :error="detailsModel.updatedate.error" :isEmptyCaption="false" labelPos="LEFT">
    <app-span   name='updatedate'
:value="data.updatedate" style=""></app-span>
</app-form-item>

</i-col>
    
    </row>
</app-form-group>

</i-col>


            </tab-pane> 
    </tabs>
    </row>
</i-form>
</template>

<script lang='tsx'>
import { Vue, Component, Prop, Provide, Emit, Watch, Model } from 'vue-property-decorator';
import { CreateElement } from 'vue';
import { Subject, Subscription } from 'rxjs';
import { ControlInterface } from '@/interface/control';
import { UIActionTool,Util } from '@/utils';
import EMWPListService from '@/service/emwplist/emwplist-service';
import Main9Service from './main9-form-service';

import EMWPListUIService from '@/uiservice/emwplist/emwplist-ui-service';
import { FormButtonModel, FormPageModel, FormItemModel, FormDRUIPartModel, FormPartModel, FormGroupPanelModel, FormIFrameModel, FormRowItemModel, FormTabPageModel, FormTabPanelModel, FormUserControlModel } from '@/model/form-detail';
import { debounceTime, distinctUntilChanged } from 'rxjs/operators';


@Component({
    components: {
      
    }
})
export default class Main9Base extends Vue implements ControlInterface {

    /**
     * 名称
     *
     * @type {string}
     * @memberof Main9
     */
    @Prop() public name?: string;

    /**
     * 视图通讯对象
     *
     * @type {Subject<ViewState>}
     * @memberof Main9
     */
    @Prop() public viewState!: Subject<ViewState>;

    /**
     * 应用上下文
     *
     * @type {*}
     * @memberof Main9
     */
    @Prop() public context: any;

    /**
     * 视图参数
     *
     * @type {*}
     * @memberof Main9
     */
    @Prop() public viewparams: any;

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main9
     */
    public viewStateEvent: Subscription | undefined;

    /**
     * 获取部件类型
     *
     * @returns {string}
     * @memberof Main9
     */
    public getControlType(): string {
        return 'FORM'
    }



    /**
     * 计数器服务对象集合
     *
     * @type {Array<*>}
     * @memberof Main9
     */    
    public counterServiceArray:Array<any> = [];

    /**
     * 建构部件服务对象
     *
     * @type {Main9Service}
     * @memberof Main9
     */
    public service: Main9Service = new Main9Service({ $store: this.$store });

    /**
     * 实体服务对象
     *
     * @type {EMWPListService}
     * @memberof Main9
     */
    public appEntityService: EMWPListService = new EMWPListService({ $store: this.$store });
    

    /**
     * 逻辑事件
     *
     * @param {*} [params={}]
     * @param {*} [tag]
     * @param {*} [$event]
     * @memberof 
     */
    public form_grouppanel3_u0117665_click(params: any = {}, tag?: any, $event?: any) {
        // 取数
        let datas: any[] = [];
        let xData: any = null;
        // _this 指向容器对象
        const _this: any = this;
        let paramJO:any = {};
        
        let contextJO:any = {};
        xData = this;
        if (_this.getDatas && _this.getDatas instanceof Function) {
            datas = [..._this.getDatas()];
        }
        // 界面行为
        const curUIService:EMWPListUIService  = new EMWPListUIService();
        curUIService.EMWPList_FillCost(datas,contextJO, paramJO,  $event, xData,this,"EMWPList");
    }


    /**
     * 关闭视图
     *
     * @param {any} args
     * @memberof Main9
     */
    public closeView(args: any): void {
        let _this: any = this;
        _this.$emit('closeview', [args]);
    }

    /**
     *  计数器刷新
     *
     * @memberof Main9
     */
    public counterRefresh(){
        const _this:any =this;
        if(_this.counterServiceArray && _this.counterServiceArray.length >0){
            _this.counterServiceArray.forEach((item:any) =>{
                if(item.refreshData && item.refreshData instanceof Function){
                    item.refreshData();
                }
            })
        }
    }


    
    /**
     * 获取多项数据
     *
     * @returns {any[]}
     * @memberof Main9
     */
    public getDatas(): any[] {
        return [this.data];
    }

    /**
     * 获取单项树
     *
     * @returns {*}
     * @memberof Main9
     */
    public getData(): any {
        return this.data;
    }

    /**
     * 是否默认保存
     *
     * @type {boolean}
     * @memberof Main9
     */
    @Prop({ default: false }) public autosave?: boolean;

    /**
     * 显示处理提示
     *
     * @type {boolean}
     * @memberof Main9
     */
    @Prop({ default: true }) public showBusyIndicator?: boolean;

    /**
     * 部件行为--submit
     *
     * @type {string}
     * @memberof Main9
     */
    @Prop() public WFSubmitAction!: string;
    
    /**
     * 部件行为--start
     *
     * @type {string}
     * @memberof Main9
     */
    @Prop() public WFStartAction!: string;
    
    /**
     * 部件行为--update
     *
     * @type {string}
     * @memberof Main9
     */
    @Prop() public updateAction!: string;
    
    /**
     * 部件行为--remove
     *
     * @type {string}
     * @memberof Main9
     */
    @Prop() public removeAction!: string;
    
    /**
     * 部件行为--loaddraft
     *
     * @type {string}
     * @memberof Main9
     */
    @Prop() public loaddraftAction!: string;
    
    /**
     * 部件行为--load
     *
     * @type {string}
     * @memberof Main9
     */
    @Prop() public loadAction!: string;
    
    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main9
     */
    @Prop() public createAction!: string;

    /**
     * 部件行为--create
     *
     * @type {string}
     * @memberof Main9
     */
    @Prop() public searchAction!: string;

    /**
     * 视图标识
     *
     * @type {string}
     * @memberof Main9
     */
    @Prop() public viewtag!: string;

    /**
     * 表单状态
     *
     * @type {Subject<any>}
     * @memberof Main9
     */
    public formState: Subject<any> = new Subject();

    /**
     * 忽略表单项值变化
     *
     * @type {boolean}
     * @memberof Main9
     */
    public ignorefieldvaluechange: boolean = false;

    /**
     * 数据变化
     *
     * @public
     * @type {Subject<any>}
     * @memberof Main9
     */
    public dataChang: Subject<any> = new Subject();

    /**
     * 视图状态事件
     *
     * @public
     * @type {(Subscription | undefined)}
     * @memberof Main9
     */
    public dataChangEvent: Subscription | undefined;

    /**
     * 原始数据
     *
     * @public
     * @type {*}
     * @memberof Main9
     */
    public oldData: any = {};

    /**
     * 表单数据对象
     *
     * @type {*}
     * @memberof Main9
     */
    public data: any = {
        srfupdatedate: null,
        srforikey: null,
        srfkey: null,
        srfmajortext: null,
        srftempmode: null,
        srfuf: null,
        srfdeid: null,
        srfsourcekey: null,
        emwplistid: null,
        wplisttype: null,
        adate: null,
        useto: null,
        equipname: null,
        objname: null,
        equips: null,
        aempname: null,
        deptname: null,
        teamname: null,
        hdate: null,
        wpliststate: null,
        need3q: null,
        lastdate: null,
        itemname: null,
        rempname: null,
        asum: null,
        itemdesc: null,
        apprempname: null,
        apprdate: null,
        wplistcostname: null,
        orgid: null,
        description: null,
        createman: null,
        createdate: null,
        updateman: null,
        updatedate: null,
        emwplist:null,
    };

    /**
      * 当前执行的行为逻辑
      *
      * @type {string}
      * @memberof Main9
      */
    public currentAction: string = "";

    /**
      * 关系界面计数器
      *
      * @type {number}
      * @memberof Main9
      */
    public drcounter: number = 0;

    /**
      * 需要等待关系界面保存时，第一次调用save参数的备份
      *
      * @type {number}
      * @memberof Main9
      */
    public drsaveopt: any = {};

    /**
      * 表单保存回调存储对象
      *
      * @type {any}
      * @memberof Main9
      */
    public saveState:any ;

    /**
     * 属性值规则
     *
     * @type {*}
     * @memberof Main9
     */
    public rules: any = {
        srfupdatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
        srforikey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfkey: [
            { type: 'string', message: '采购申请号 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '采购申请号 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '采购申请号 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '采购申请号 值不能为空', trigger: 'blur' },
        ],
        srfmajortext: [
            { type: 'string', message: '采购申请名称 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '采购申请名称 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '采购申请名称 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '采购申请名称 值不能为空', trigger: 'blur' },
        ],
        srftempmode: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfuf: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfdeid: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        srfsourcekey: [
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: ' 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: ' 值不能为空', trigger: 'blur' },
        ],
        emwplistid: [
            { type: 'string', message: '采购申请号(自动) 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '采购申请号(自动) 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '采购申请号(自动) 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '采购申请号(自动) 值不能为空', trigger: 'blur' },
        ],
        wplisttype: [
            { type: 'string', message: '请购类型 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '请购类型 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '请购类型 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '请购类型 值不能为空', trigger: 'blur' },
        ],
        adate: [
            { type: 'string', message: '申请日期 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '申请日期 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '申请日期 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '申请日期 值不能为空', trigger: 'blur' },
        ],
        useto: [
            { type: 'string', message: '用途 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '用途 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '用途 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '用途 值不能为空', trigger: 'blur' },
        ],
        equipname: [
            { type: 'string', message: '设备 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备 值不能为空', trigger: 'blur' },
        ],
        objname: [
            { type: 'string', message: '位置 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '位置 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '位置 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '位置 值不能为空', trigger: 'blur' },
        ],
        equips: [
            { type: 'string', message: '设备集合 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '设备集合 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '设备集合 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '设备集合 值不能为空', trigger: 'blur' },
        ],
        aempname: [
            { type: 'string', message: '申请人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '申请人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '申请人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '申请人 值不能为空', trigger: 'blur' },
        ],
        deptname: [
            { type: 'string', message: '申请部门 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '申请部门 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '申请部门 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '申请部门 值不能为空', trigger: 'blur' },
        ],
        teamname: [
            { type: 'string', message: '申请班组 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '申请班组 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '申请班组 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '申请班组 值不能为空', trigger: 'blur' },
        ],
        hdate: [
            { type: 'string', message: '希望到货日期 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '希望到货日期 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '希望到货日期 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '希望到货日期 值不能为空', trigger: 'blur' },
        ],
        wpliststate: [
            { type: 'string', message: '请购状态 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '请购状态 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '请购状态 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '请购状态 值不能为空', trigger: 'blur' },
        ],
        need3q: [
            { type: 'string', message: '需要3次询价 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '需要3次询价 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '需要3次询价 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '需要3次询价 值不能为空', trigger: 'blur' },
        ],
        lastdate: [
            { type: 'string', message: '上次请购时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '上次请购时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '上次请购时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '上次请购时间 值不能为空', trigger: 'blur' },
        ],
        itemname: [
            { type: 'string', message: '物品 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品 值不能为空', trigger: 'blur' },
        ],
        rempname: [
            { type: 'string', message: '采购员 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '采购员 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '采购员 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '采购员 值不能为空', trigger: 'blur' },
        ],
        asum: [
            { type: 'number', message: '请购数 值必须为数值类型', trigger: 'change' },
            { type: 'number', message: '请购数 值必须为数值类型', trigger: 'blur' },
            { required: false, type: 'number', message: '请购数 值不能为空', trigger: 'change' },
            { required: false, type: 'number', message: '请购数 值不能为空', trigger: 'blur' },
        ],
        itemdesc: [
            { type: 'string', message: '物品备注 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '物品备注 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '物品备注 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '物品备注 值不能为空', trigger: 'blur' },
        ],
        apprempname: [
            { type: 'string', message: '批准人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '批准人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '批准人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '批准人 值不能为空', trigger: 'blur' },
        ],
        apprdate: [
            { type: 'string', message: '批准日期 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '批准日期 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '批准日期 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '批准日期 值不能为空', trigger: 'blur' },
        ],
        wplistcostname: [
            { type: 'string', message: '询价结果 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '询价结果 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '询价结果 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '询价结果 值不能为空', trigger: 'blur' },
        ],
        orgid: [
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '组织 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '组织 值不能为空', trigger: 'blur' },
        ],
        description: [
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '描述 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '描述 值不能为空', trigger: 'blur' },
        ],
        createman: [
            { type: 'string', message: '建立人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '建立人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '建立人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '建立人 值不能为空', trigger: 'blur' },
        ],
        createdate: [
            { type: 'string', message: '建立时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '建立时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '建立时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '建立时间 值不能为空', trigger: 'blur' },
        ],
        updateman: [
            { type: 'string', message: '更新人 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新人 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新人 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新人 值不能为空', trigger: 'blur' },
        ],
        updatedate: [
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'change' },
            { type: 'string', message: '更新时间 值必须为字符串类型', trigger: 'blur' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'change' },
            { required: false, type: 'string', message: '更新时间 值不能为空', trigger: 'blur' },
        ],
    }

    /**
     * 详情模型集合
     *
     * @type {*}
     * @memberof Main9
     */
    public detailsModel: any = {
        grouppanel1: new FormGroupPanelModel({ caption: '分组面板', detailType: 'GROUPPANEL', name: 'grouppanel1', visible: true, isShowCaption: false, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwplist.main9_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel2: new FormGroupPanelModel({ caption: '申请信息', detailType: 'GROUPPANEL', name: 'grouppanel2', visible: true, isShowCaption: false, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwplist.main9_form', extractMode: 'ITEM', details: [] } })
, 
        grouppanel18: new FormGroupPanelModel({ caption: '采购内容', detailType: 'GROUPPANEL', name: 'grouppanel18', visible: true, isShowCaption: false, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwplist.main9_form', extractMode: 'ITEM', details: [] } })
, 
        druipart1: new FormDRUIPartModel({ caption: '询价单', detailType: 'DRUIPART', name: 'druipart1', visible: true, isShowCaption: true, form: this })
, 
        grouppanel3: new FormGroupPanelModel({ caption: '询价单', detailType: 'GROUPPANEL', name: 'grouppanel3', visible: true, isShowCaption: true, form: this, uiActionGroup: { caption: '询价填报完成', langbase: 'entities.emwplist.main9_form', extractMode: 'ITEM', details: [{ name: 'grouppanel3_u0117665', caption: '询价填报完成', uiactiontag: 'fillcost', icon: 'fa fa-edit' }] } })
, 
        formpage1: new FormPageModel({ caption: '基本信息', detailType: 'FORMPAGE', name: 'formpage1', visible: true, isShowCaption: true, form: this })
, 
        grouppanel27: new FormGroupPanelModel({ caption: '操作信息', detailType: 'GROUPPANEL', name: 'grouppanel27', visible: true, isShowCaption: false, form: this, uiActionGroup: { caption: '', langbase: 'entities.emwplist.main9_form', extractMode: 'ITEM', details: [] } })
, 
        formpage26: new FormPageModel({ caption: '其它', detailType: 'FORMPAGE', name: 'formpage26', visible: true, isShowCaption: true, form: this })
, 
        srfupdatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'srfupdatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srforikey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srforikey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfkey: new FormItemModel({ caption: '采购申请号', detailType: 'FORMITEM', name: 'srfkey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        srfmajortext: new FormItemModel({ caption: '采购申请名称', detailType: 'FORMITEM', name: 'srfmajortext', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srftempmode: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srftempmode', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfuf: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfuf', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfdeid: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfdeid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        srfsourcekey: new FormItemModel({ caption: '', detailType: 'FORMITEM', name: 'srfsourcekey', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        emwplistid: new FormItemModel({ caption: '采购申请号(自动)', detailType: 'FORMITEM', name: 'emwplistid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        wplisttype: new FormItemModel({ caption: '请购类型', detailType: 'FORMITEM', name: 'wplisttype', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        adate: new FormItemModel({ caption: '申请日期', detailType: 'FORMITEM', name: 'adate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        useto: new FormItemModel({ caption: '用途', detailType: 'FORMITEM', name: 'useto', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        equipname: new FormItemModel({ caption: '设备', detailType: 'FORMITEM', name: 'equipname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        objname: new FormItemModel({ caption: '位置', detailType: 'FORMITEM', name: 'objname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        equips: new FormItemModel({ caption: '设备集合', detailType: 'FORMITEM', name: 'equips', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        aempname: new FormItemModel({ caption: '申请人', detailType: 'FORMITEM', name: 'aempname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        deptname: new FormItemModel({ caption: '申请部门', detailType: 'FORMITEM', name: 'deptname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        teamname: new FormItemModel({ caption: '申请班组', detailType: 'FORMITEM', name: 'teamname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        hdate: new FormItemModel({ caption: '希望到货日期', detailType: 'FORMITEM', name: 'hdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        wpliststate: new FormItemModel({ caption: '请购状态', detailType: 'FORMITEM', name: 'wpliststate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        need3q: new FormItemModel({ caption: '需要3次询价', detailType: 'FORMITEM', name: 'need3q', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        lastdate: new FormItemModel({ caption: '上次请购时间', detailType: 'FORMITEM', name: 'lastdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        itemname: new FormItemModel({ caption: '物品', detailType: 'FORMITEM', name: 'itemname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        rempname: new FormItemModel({ caption: '采购员', detailType: 'FORMITEM', name: 'rempname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        asum: new FormItemModel({ caption: '请购数', detailType: 'FORMITEM', name: 'asum', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        itemdesc: new FormItemModel({ caption: '物品备注', detailType: 'FORMITEM', name: 'itemdesc', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        apprempname: new FormItemModel({ caption: '批准人', detailType: 'FORMITEM', name: 'apprempname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        apprdate: new FormItemModel({ caption: '批准日期', detailType: 'FORMITEM', name: 'apprdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        wplistcostname: new FormItemModel({ caption: '询价结果', detailType: 'FORMITEM', name: 'wplistcostname', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        orgid: new FormItemModel({ caption: '组织', detailType: 'FORMITEM', name: 'orgid', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        description: new FormItemModel({ caption: '描述', detailType: 'FORMITEM', name: 'description', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 3 })
, 
        createman: new FormItemModel({ caption: '建立人', detailType: 'FORMITEM', name: 'createman', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        createdate: new FormItemModel({ caption: '建立时间', detailType: 'FORMITEM', name: 'createdate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        updateman: new FormItemModel({ caption: '更新人', detailType: 'FORMITEM', name: 'updateman', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        updatedate: new FormItemModel({ caption: '更新时间', detailType: 'FORMITEM', name: 'updatedate', visible: true, isShowCaption: true, form: this, disabled: false, enableCond: 0 })
, 
        form: new FormTabPanelModel({ caption: 'form', detailType: 'TABPANEL', name: 'form', visible: true, isShowCaption: true, form: this, tabPages: [{ name: 'formpage1', index: 0, visible: true }, { name: 'formpage26', index: 1, visible: true }] }),
    };

    /**
     * 监控表单属性 srfupdatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.srfupdatedate')
    onSrfupdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfupdatedate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srforikey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.srforikey')
    onSrforikeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srforikey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfkey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.srfkey')
    onSrfkeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfkey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfmajortext 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.srfmajortext')
    onSrfmajortextChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfmajortext', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srftempmode 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.srftempmode')
    onSrftempmodeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srftempmode', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfuf 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.srfuf')
    onSrfufChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfuf', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfdeid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.srfdeid')
    onSrfdeidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfdeid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 srfsourcekey 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.srfsourcekey')
    onSrfsourcekeyChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'srfsourcekey', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 emwplistid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.emwplistid')
    onEmwplistidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'emwplistid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wplisttype 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.wplisttype')
    onWplisttypeChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wplisttype', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 adate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.adate')
    onAdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'adate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 useto 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.useto')
    onUsetoChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'useto', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 equipname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.equipname')
    onEquipnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'equipname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 objname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.objname')
    onObjnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'objname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 equips 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.equips')
    onEquipsChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'equips', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 aempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.aempname')
    onAempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'aempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 deptname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.deptname')
    onDeptnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'deptname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 teamname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.teamname')
    onTeamnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'teamname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 hdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.hdate')
    onHdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'hdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wpliststate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.wpliststate')
    onWpliststateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wpliststate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 need3q 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.need3q')
    onNeed3qChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'need3q', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 lastdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.lastdate')
    onLastdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'lastdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 itemname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.itemname')
    onItemnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'itemname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 rempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.rempname')
    onRempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'rempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 asum 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.asum')
    onAsumChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'asum', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 itemdesc 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.itemdesc')
    onItemdescChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'itemdesc', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 apprempname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.apprempname')
    onApprempnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'apprempname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 apprdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.apprdate')
    onApprdateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'apprdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 wplistcostname 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.wplistcostname')
    onWplistcostnameChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'wplistcostname', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 orgid 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.orgid')
    onOrgidChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'orgid', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 description 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.description')
    onDescriptionChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'description', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 createman 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.createman')
    onCreatemanChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'createman', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 createdate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.createdate')
    onCreatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'createdate', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 updateman 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.updateman')
    onUpdatemanChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'updateman', newVal: newVal, oldVal: oldVal });
    }

    /**
     * 监控表单属性 updatedate 值
     *
     * @param {*} newVal
     * @param {*} oldVal
     * @memberof Main9
     */
    @Watch('data.updatedate')
    onUpdatedateChange(newVal: any, oldVal: any) {
        this.formDataChange({ name: 'updatedate', newVal: newVal, oldVal: oldVal });
    }


    /**
     * 重置表单项值
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main9
     */
    public resetFormData({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
    }

    /**
      * 置空对象
      *
      * @param {any[]} args
      * @memberof EditForm
      */
    public ResetData(_datas:any){
        if(Object.keys(_datas).length >0){
            Object.keys(_datas).forEach((name: string) => {
                if (this.data.hasOwnProperty(name)) {
                    this.data[name] = null;
                }
            });
        }
    }

    /**
     * 表单逻辑
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @memberof Main9
     */
    public formLogic({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
                











































    }

    /**
     * 表单值变化
     *
     * @public
     * @param {{ name: string, newVal: any, oldVal: any }} { name, newVal, oldVal }
     * @returns {void}
     * @memberof Main9
     */
    public formDataChange({ name, newVal, oldVal }: { name: string, newVal: any, oldVal: any }): void {
        if (this.ignorefieldvaluechange) {
            return;
        }
        this.resetFormData({ name: name, newVal: newVal, oldVal: oldVal });
        this.formLogic({ name: name, newVal: newVal, oldVal: oldVal });
        this.dataChang.next(JSON.stringify(this.data));
    }

    /**
     * 表单加载完成
     *
     * @public
     * @param {*} [data={}]
     * @param {string} [action]
     * @memberof Main9
     */
    public onFormLoad(data: any = {},action:string): void {
        if(Object.is(action,"save") || Object.is(action,"autoSave") || Object.is(action,"submit"))
        // 更新context的实体主键
        if(data.emwplist){
            Object.assign(this.context,{emwplist:data.emwplist})
        }
        this.setFormEnableCond(data);
        this.fillForm(data,action);
        this.oldData = {};
        Object.assign(this.oldData, JSON.parse(JSON.stringify(this.data)));
        this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: false });
        this.formLogic({ name: '', newVal: null, oldVal: null });
    }

    /**
     * 值填充
     *
     * @param {*} [_datas={}]
     * @param {string} [action]
     * @memberof Main9
     */
    public fillForm(_datas: any = {},action:string): void {
        this.ignorefieldvaluechange = true;
        Object.keys(_datas).forEach((name: string) => {
            if (this.data.hasOwnProperty(name)) {
                this.data[name] = _datas[name];
            }
        });
        if(Object.is(action,'loadDraft')){
            this.createDefault();
        }
        if(Object.is(action,'load')){
            this.updateDefault();
        }
        this.$nextTick(function () {
            this.ignorefieldvaluechange = false;
        })
    }

    /**
     * 设置表单项是否启用
     *
     * @public
     * @param {*} data
     * @memberof Main9
     */
    public setFormEnableCond(data: any): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setEnableCond(data.srfuf);
        });
    }

    /**
     * 重置草稿表单状态
     *
     * @public
     * @memberof Main9
     */
    public resetDraftFormStates(): void {
        const form: any = this.$refs.form;
        if (form) {
            form.resetFields();
        }
    }

    /**
     * 重置校验结果
     *
     * @memberof Main9
     */
    public resetValidates(): void {
        Object.values(this.detailsModel).forEach((detail: any) => {
            if (!Object.is(detail.detailType, 'FORMITEM')) {
                return;
            }
            const formItem: FormItemModel = detail;
            formItem.setError('');
        });
    }

    /**
     * 填充校验结果 （后台）
     *
     * @param {any[]} fieldErrors
     * @memberof Main9
     */
    public fillValidates(fieldErrors: any[]): void {
        fieldErrors.forEach((error: any) => {
            const formItem: FormItemModel = this.detailsModel[error.field];
            if (!formItem) {
                return;
            }
            this.$nextTick(() => {
                formItem.setError(error.message);
            });
        });
    }

    /**
     * 表单校验状态
     *
     * @returns {boolean} 
     * @memberof Main9
     */
    public formValidateStatus(): boolean {
        const form: any = this.$refs.form;
        let validatestate: boolean = true;
        form.validate((valid: boolean) => {
            validatestate = valid ? true : false;
        });
        return validatestate
    }

    /**
     * 获取全部值
     *
     * @returns {*}
     * @memberof Main9
     */
    public getValues(): any {
        return this.data;
    }

    /**
     * 表单项值变更
     *
     * @param {{ name: string, value: any }} $event
     * @returns {void}
     * @memberof Main9
     */
    public onFormItemValueChange($event: { name: string, value: any }): void {
        if (!$event) {
            return;
        }
        if (!$event.name || Object.is($event.name, '') || !this.data.hasOwnProperty($event.name)) {
            return;
        }
        this.data[$event.name] = $event.value;
    }

    /**
     * 设置数据项值
     *
     * @param {string} name
     * @param {*} value
     * @returns {void}
     * @memberof Main9
     */
    public setDataItemValue(name: string, value: any): void {
        if (!name || Object.is(name, '') || !this.data.hasOwnProperty(name)) {
            return;
        }
        if (Object.is(this.data[name], value)) {
            return;
        }
        this.data[name] = value;
    }



    /**
     * 分组界面行为事件
     *
     * @param {*} $event
     * @memberof Main9
     */
    public groupUIActionClick($event: any): void {
        if (!$event) {
            return;
        }
        const item:any = $event.item;
        if (Object.is(item.name, 'grouppanel3_u0117665')) {
            this.form_grouppanel3_u0117665_click(null, null, $event.event);
        }
    }

    /**
     * Vue声明周期(处理组件的输入属性)
     *
     * @memberof Main9
     */
    public created(): void {
        this.afterCreated();
    }

    /**
     * 执行created后的逻辑
     *
     *  @memberof Main9
     */    
    public afterCreated(){
        if (this.viewState) {
            this.viewStateEvent = this.viewState.subscribe(({ tag, action, data }) => {
                if (!Object.is(tag, this.name)) {
                    return;
                }
                if (Object.is('autoload', action)) {
                    this.autoLoad(data);
                }
                if (Object.is('load', action)) {
                    this.load(data);
                }
                if (Object.is('loaddraft', action)) {
                    this.loadDraft(data);
                }
                if (Object.is('save', action)) {
                    this.save(data,data.showResultInfo);
                }
                if (Object.is('remove', action)) {
                    this.remove(data);
                }
                if (Object.is('saveandexit', action)) {
                    this.saveAndExit(data);
                }
                if (Object.is('saveandnew', action)) {
                    this.saveAndNew(data);
                }
                if (Object.is('removeandexit', action)) {
                    this.removeAndExit(data);
                }
                if (Object.is('refresh', action)) {
                    this.refresh(data);
                }
            });
        }
        this.dataChang
            .pipe(
                debounceTime(300),
                distinctUntilChanged()
            ).subscribe((data: any) => {
                if (this.autosave) {
                    this.autoSave();
                }
                const state = !Object.is(JSON.stringify(this.oldData), JSON.stringify(this.data)) ? true : false;
                this.$store.commit('viewaction/setViewDataChange', { viewtag: this.viewtag, viewdatachange: state });
            });
    }

    /**
     * vue 生命周期
     *
     * @memberof Main9
     */
    public destroyed() {
        this.afterDestroy();
    }

    /**
     * 执行destroyed后的逻辑
     *
     * @memberof Main9
     */
    public afterDestroy() {
        if (this.viewStateEvent) {
            this.viewStateEvent.unsubscribe();
        }
        if (this.dataChangEvent) {
            this.dataChangEvent.unsubscribe();
        }
    }

    /**
     * 拷贝内容
     *
     * @param {*} [arg={}]
     * @memberof @memberof Main9
     */
    public copy(arg: any = {}): void {
        this.loadDraft(arg);
    }

    /**
     *打印
     *@memberof @memberof Main9
     */
    public print(){
        let _this:any = this;
        _this.$print({id:'form',popTitle:'采购申请-询价单-填报<主信息>'});
    }

    /**
     * 部件刷新
     *
     * @param {any[]} args
     * @memberof Main9
     */
    public refresh(args: any[]): void {
        let arg: any = {};
        Object.assign(arg,args[0]);
        if (this.data.srfkey && !Object.is(this.data.srfkey, '')) {
            Object.assign(arg, { srfkey: this.data.srfkey });
            this.load(arg);
            return;
        }
        if (this.data.srfkeys && !Object.is(this.data.srfkeys, '')) {
            Object.assign(arg, { srfkey: this.data.srfkeys });
            this.load(arg);
            return;
        }
    }

    /**
     * 自动加载
     *
     * @param {*} [arg={}]
     * @returns {void}
     * @memberof Main9
     */
    public autoLoad(arg: any = {}): void {
        if (arg.srfkey && !Object.is(arg.srfkey, '')) {
            Object.assign(arg, { srfkey: arg.srfkey });
            this.load(arg);
            return;
        }
        if (arg.srfkeys && !Object.is(arg.srfkeys, '')) {
            Object.assign(arg, { srfkey: arg.srfkeys });
            this.load(arg);
            return;
        }
        this.loadDraft(arg);
    }

    /**
     * 加载
     *
     * @public
     * @param {*} [opt={}]
     * @memberof Main9
     */
    public load(opt: any = {}): void {
        if(!this.loadAction){
            this.$Notice.error({ title: '错误', desc: 'EMWPListFillCostEditView9视图表单loadAction参数未配置' });
            return;
        }
        const arg: any = { ...opt };
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        const get: Promise<any> = this.service.get(this.loadAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        get.then((response: any) => {
            if (response && response.status === 200) {
                const data = response.data;
                this.onFormLoad(data,'load');
                this.$emit('load', data);
                this.$nextTick(() => {
                    this.formState.next({ type: 'load', data: data });
                });
            }
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 加载草稿
     *
     * @param {*} [opt={}]
     * @memberof Main9
     */
    public loadDraft(opt: any = {}): void {
        if(!this.loaddraftAction){
            this.$Notice.error({ title: '错误', desc: 'EMWPListFillCostEditView9视图表单loaddraftAction参数未配置' });
            return;
        }
        const arg: any = { ...opt } ;
        let viewparamResult:any = Object.assign(arg,this.viewparams);
        let post: Promise<any> = this.service.loadDraft(this.loaddraftAction,JSON.parse(JSON.stringify(this.context)),{viewparams:viewparamResult}, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            if(data.emwplist){
                Object.assign(this.context,{emwplist:data.emwplist})
            }
            this.resetDraftFormStates();
            this.onFormLoad(data,'loadDraft');
            this.$emit('load', data);
            this.$nextTick(() => {
                this.formState.next({ type: 'load', data: data });
            });
            setTimeout(() => {
                const form: any = this.$refs.form;
                if (form) {
                    form.fields.forEach((field: any) => {
                        field.validateMessage = "";
                        field.validateState = "";
                        field.validateStatus = false;
                    });
                }
            });
        }).catch((response: any) => {
            if (response && response.status  && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 自动保存
     *
     * @param {*} [opt={}]
     * @memberof Main9
     */
    public autoSave(opt: any = {}): void {
        if (!this.formValidateStatus()) {
            return;
        }
        const arg: any = { ...opt };
        const data = this.getValues();
        Object.assign(arg, data);
        const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
        if(!action){
            let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
            this.$Notice.error({ title: '错误', desc: 'EMWPListFillCostEditView9视图表单'+actionName+'参数未配置' });
            return;
        }
        Object.assign(arg,{viewparams:this.viewparams});
        const post: Promise<any> = this.service.add(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response: any) => {
            if (!response.status || response.status !== 200) {
                if (response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                }
                return;
            }

            const data = response.data;
            this.onFormLoad(data,'autoSave');
            this.$emit('save', data);
            this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
            this.$nextTick(() => {
                this.formState.next({ type: 'save', data: data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 保存
     *
     * @param {*} [opt={}]
     * @param {boolean} [showResultInfo] 
     * @param {boolean} [ifStateNext] formState是否下发通知
     * @returns {Promise<any>}
     * @memberof Main9
     */
    public async save(opt: any = {}, showResultInfo?: boolean, ifStateNext: boolean = true): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            showResultInfo = showResultInfo === undefined ? true : false;
            if (!this.formValidateStatus()) {
                this.$Notice.error({ title: '错误', desc: '值规则校验异常' });
                return;
            }
            const arg: any = { ...opt };
            const data = this.getValues();
            Object.assign(arg, data);
            Object.assign(arg, this.context);
            if (ifStateNext) {
                this.drcounter = 1;
                if(this.drcounter !== 0){
                    this.drsaveopt = opt;
                    this.formState.next({ type: 'beforesave', data: arg });//先通知关系界面保存
                    this.saveState = resolve;
                    return;
                }
            }
            const action: any = Object.is(data.srfuf, '1') ? this.updateAction : this.createAction;
            if(!action){
                let actionName:any = Object.is(data.srfuf, '1')?"updateAction":"createAction";
                this.$Notice.error({ title: '错误', desc: 'EMWPListFillCostEditView9视图表单'+actionName+'参数未配置' });
                return;
            }
            Object.assign(arg,{viewparams:this.viewparams});
            const post: Promise<any> = Object.is(data.srfuf, '1')?this.service.update(action, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(action,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
            post.then((response: any) => {
                if (!response.status || response.status !== 200) {
                    if (response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                    }
                    return;
                }

                const data = response.data;
                this.onFormLoad(data,'save');
                this.$emit('save', data);
                this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: data });
                });
                if (showResultInfo) {
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;保存成功！' });
                }
                resolve(response);
            }).catch((response: any) => {
                if (response && response.status  && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
        })
    }

    /**
    * 删除
    *
    * @public
    * @param {*} [opt={}]
    * @memberof EditForm
    */
    public remove(opt:Array<any> = [],showResultInfo?: boolean): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            if(!this.removeAction){
                this.$Notice.error({ title: '错误', desc: 'EMWPListFillCostEditView9视图表单removeAction参数未配置' });
                return;
            }
            const arg: any = opt[0];
            const _this: any = this;
            Object.assign(arg,{viewparams:this.viewparams});
            this.service.delete(_this.removeAction, JSON.parse(JSON.stringify(this.context)),arg, showResultInfo).then((response: any) => {
                if (response) {
                    const data = response.data;
                    this.$emit('remove',data);
                    this.formState.next({ type: 'remove', data: data });
                    this.data.ismodify = false;
                    this.$Notice.success({ title: '', desc: (data.srfmajortext ? data.srfmajortext : '') + '&nbsp;删除成功！' });
                    resolve(response);
                }
            }).catch((error: any) => {
                const { data: _data } = error;
                this.$Notice.error({ title: _data.title, desc: _data.message });
                reject(error);
            });
        });
    }

    /**
     * 工作流启动
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main9
     */
    public async wfstart(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
            const _this: any = this;
            const post: Promise<any> = _this.save({},false);
            post.then((response:any) =>{
                const arg:any = response.data;
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfstart(_this.WFStartAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流启动失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.$Notice.info({ title: '', desc: '工作流启动成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        });
    }

    /**
     * 工作流提交
     *
     * @param {*} [data={}]
     * @param {*} [localdata={}]
     * @returns {Promise<any>}
     * @memberof Main9
     */
    public async wfsubmit(data: any,localdata?:any): Promise<any> {
        return new Promise((resolve: any, reject: any) => {
        const _this: any = this;
        const arg: any = data[0];
        Object.assign(arg,{viewparams:this.viewparams});
        if (!arg.emwplist || Object.is(arg.emwplist, '')) {
            return;
        }
        const post: Promise<any> = Object.is(arg.srfuf, '1')?this.service.update(this.updateAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator):this.service.add(this.createAction,JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator);
        post.then((response:any) =>{
                const arg:any = response.data;
                // 保存完成UI处理
                this.onFormLoad(arg,'save');
                this.$emit('save', arg);
                this.$nextTick(() => {
                    this.formState.next({ type: 'save', data: arg });
                });
                // 准备提交参数
                if(this.viewparams){
                    Object.assign(arg,{viewparams:this.viewparams});
                }
                const result: Promise<any> = this.service.wfsubmit(_this.WFSubmitAction, JSON.parse(JSON.stringify(this.context)),arg, this.showBusyIndicator,localdata);
                result.then((response: any) => {
                    if (!response || response.status !== 200) {
                        if(response.data){
                            this.$Notice.error({ title: '', desc: '工作流提交失败, ' + response.data.message });
                        }
                        return;
                    }
                    this.onFormLoad(arg,'submit');
                    this.$store.dispatch('viewaction/datasaved', { viewtag: this.viewtag });
                    this.$Notice.info({ title: '', desc: '工作流提交成功' });
                    resolve(response);
            }).catch((response: any) => {
                if (response && response.status && response.data) {
                    this.$Notice.error({ title: '错误', desc: response.data.message });
                    reject(response);
                    return;
                }
                if (!response || !response.status || !response.data) {
                    this.$Notice.error({ title: '错误', desc: '系统异常' });
                    reject(response);
                    return;
                }
                reject(response);
            });
            }).catch((response: any) => {
                    if (response && response.status && response.data) {
                        this.$Notice.error({ title: '错误', desc: response.data.message });
                        reject(response);
                        return;
                    }
                    if (!response || !response.status || !response.data) {
                        this.$Notice.error({ title: '错误', desc: '系统异常' });
                        reject(response);
                        return;
                    }
                    reject(response);
            })
        })
    }

    /**
     * 表单项更新
     *
     * @param {string} mode 界面行为名称
     * @param {*} [data={}] 请求数据
     * @param {string[]} updateDetails 更新项
     * @param {boolean} [showloading] 是否显示加载状态
     * @returns {void}
     * @memberof Main9
     */
    public updateFormItems(mode: string, data: any = {}, updateDetails: string[], showloading?: boolean): void {
        if (!mode || (mode && Object.is(mode, ''))) {
            return;
        }
        const arg: any = { ...data };
        Object.assign(arg,this.viewparams);
        const post: Promise<any> = this.service.frontLogic(mode,JSON.parse(JSON.stringify(this.context)),arg, showloading);
        post.then((response: any) => {
            if (!response || response.status !== 200) {
                this.$Notice.error({ title: '错误', desc: '表单项更新失败' });
                return;
            }
            const data = response.data;
            const _data: any = {};
            updateDetails.forEach((name: string) => {
                if (!data.hasOwnProperty(name)) {
                    return;
                }
                Object.assign(_data, { [name]: data[name] });
            });
            this.setFormEnableCond(_data);
            this.fillForm(_data,'updateFormItem');
            this.formLogic({ name: '', newVal: null, oldVal: null });
            this.dataChang.next(JSON.stringify(this.data));
            this.$nextTick(() => {
                this.formState.next({ type: 'updateformitem', ufimode: arg.srfufimode, data: _data });
            });
        }).catch((response: any) => {
            if (response && response.status && response.data) {
                this.$Notice.error({ title: '错误', desc: response.data.message });
                return;
            }
            if (!response || !response.status || !response.data) {
                this.$Notice.error({ title: '错误', desc: '系统异常' });
                return;
            }
        });
    }

    /**
     * 回车事件
     *
     * @param {*} $event
     * @memberof Main9
     */
    public onEnter($event: any): void {
    }

    /**
     * 保存并退出
     *
     * @param {any[]} args
     * @memberof Main9
     */
    public saveAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndExit";
            _this.save([arg]).then((res) =>{
                if(res){
                    _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 保存并新建
     *
     * @param {any[]} args
     * @memberof Main9
     */
    public saveAndNew(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.currentAction = "saveAndNew";
            _this.save([arg]).then((res) =>{
                _this.ResetData(res);
                _this.loadDraft({});
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
     * 删除并退出
     *
     * @param {any[]} args
     * @memberof Main9
     */
    public removeAndExit(data:any[]):Promise<any>{
        let _this = this;
        return new Promise((resolve: any, reject: any) =>{
            let arg: any = {};
            if(data && data.length > 0){
                Object.assign(arg,data[0]);
            }
            _this.remove([arg]).then((res) =>{
                if(res){
                  _this.closeView(res.data);
                }
                resolve(res);
            }).catch((error) =>{
                reject(error);
            })
        })
    }

    /**
    * 关系界面数据保存完成
    *
    * @param {any} $event
    * @memberof Main9
    */
    public drdatasaved($event:any){
        let _this = this;
        this.drcounter--;
        if(this.drcounter > 0){
            return;
        }
        this.save(this.drsaveopt, undefined, false).then((res) =>{
            this.saveState(res);
            this.drsaveopt = {};
            if(Object.is(_this.currentAction, "saveAndNew")){
                _this.ResetData(res);
                _this.loadDraft({});
            }else if(Object.is(_this.currentAction, "saveAndExit")){
                if(res){
                    _this.closeView(res.data);
                }
            }
        });
    }

    /**
     * 新建默认值
     * @memberof Main9
     */
    public createDefault(){                    
        if (this.data.hasOwnProperty('deptname')) {
            this.data['deptname'] = this.context['DEPTID'];
        }
        if (this.data.hasOwnProperty('teamname')) {
            this.data['teamname'] = this.context['TEAMID'];
        }
    }

    /**
     * 更新默认值
     * @memberof Main9
     */
    public updateDefault(){                    
    }

    
}
</script>

<style lang='less'>
@import './main9-form.less';
</style>